/*
Copyright (c) 2005-2009 TeamF1, Inc.
All rights reserved.
*/

function nextActiveFieldGet (srcObj)
    {
    if (!srcObj) return null;
    if ((srcObj.name).indexOf("ip4.") == 0)    return null;
    var currObj = null;
    var formObj = srcObj.form;
    var nFormElmnts = formObj.elements.length;
    for (var i = 0; i < nFormElmnts; i++)
        {
        currObj = formObj.elements[i];
        if (currObj.type != "hidden" &&
            !currObj.disabled)
            {
            if (srcObj == currObj && i != (nFormElmnts - 1))
               return formObj.elements[i+1]
           }
        }
    return null;
    }
 
/* 
* minVal & maxVal are the min and max values for the specified octet.
* errStr is the message that need to be displayed when the specified octet fails
* to statisfy specified values.
*/
function ipv4ByteCheck (eventObj, srcObj, minVal, maxVal, prefixStr, suffixStr)
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid IP address.';
    var errMsgL10n2 = 'for each octet.';
    var errMsgObjL10n = document.getElementById ('hd.invalIpAddr');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.foreachoctate');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    /* L10N Error Message Collection End */

    if (!eventObj || !srcObj)
         return false;
    var charUniCode = eventObj.charCode ? eventObj.charCode : eventObj.keyCode;
    /* process only 'tab', '.' keys and space*/
    if (charUniCode != 9 &&
        charUniCode != 110 && charUniCode != 190 &&
        charUniCode != 32)
         return true;
         
    var value = srcObj.value;
    /* return false if field value is empty */
    if (value.length == 0)
        return true;
    if (!minVal) minVal = 0;
    if (!maxVal) maxVal = 255;
    if (!prefixStr) prefixStr = errMsgL10n1;
    if (!suffixStr) suffixStr = errMsgL10n2;
    if (!(numericValueRangeCheck (srcObj, '', '', minVal, maxVal, true, prefixStr, suffixStr)))
         {
         srcObj.focus ();
         return false;
         }
    /* move focus to next active object if '.' is pressed */
    if (charUniCode == 110 || charUniCode == 190 ||
        charUniCode == 32)
        {
        var nextObj = nextActiveFieldGet (srcObj);
        if (nextObj)
            {
            nextObj.focus ();
            nextObj.select ();
            }
        return false;
        }
   
    return true;
    }
 
function ipv4AddrsCheck (ipv4TblIdArr)
    {
    for (var i = 0; i < ipv4TblIdArr.length; ++i)
        {
        var result = false;
        var strArr = ipv4TblIdArr[i].split(",");
        if (strArr.length > 1)
            {
            /*
            * the string will be in the following format.
            * strArr[0] - IPV4 address table ID.
            * strArr[1] - IPV4 address address type (IP,SM,NID).
            * strArr[2] - optional/mandatory (true/false).
            * strArr[3] - prefix error string.
            * strArr[4] - suffix error string.
            */
            result = ipv4AddrOctetsValidate (strArr[0], strArr[1],
                                             (strArr[2] == 'true'),
                                             true, strArr[3], strArr[4], true);
            }
        else
            result = ipv4AddrOctetsValidate (strArr[0], 'IP', false);
        if (!result) return false;
        }
     }
function ipv4AddrOctetsValidate 
    (ipv4TblId, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
    {
    if (!ipv4TblId) return false;
    var obj = document.getElementById(ipv4TblId);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    if (!ipv4AddrTypeStr) ipv4AddrTypeStr = 'IP';
    return ipv4AddrFormatCheck (objArr, ipv4AddrTypeStr, optFlag, alertFlag,
                                prefixStr, suffixStr, octetShowFlag)
    }
function checkSnetMask (snetMaskOctet, stIdx, endIdx)
	{
	var subnetOctets = [0, 128, 192, 224, 240, 248, 252, 254, 255];
	if (isNaN (snetMaskOctet)) return true;
	var errorFlag = false;
	for (var i = stIdx; i <= endIdx; i++)
		{
		if (parseInt (snetMaskOctet,10) == subnetOctets[i])
			{
			errorFlag = true;
			break;
			}
		}
	return errorFlag;
	}
function ipv4AddrFormatCheck
    (objArr, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = " remove leading 0's for octet ";
    var errMsgL10n2 = " Please enter 255 ";
    var errMsgL10n3 = " Please enter 0 ";
    var errMsgL10n4 = " Please enter 0/128/192/224/240/248/252 ";
    var errMsgL10n5 = " Please enter 0/128/192/224/240/248/252/254/255 ";
    var errMsgL10n6 = " Please enter a value between ";
    var errMsgL10n7 = "Please enter a value 0/128/192/224/240/248/252/254/255 for each octet.";
    var errMsgL10n8 = "Invalid octet length for octet ";
    var errMsgL10n9 = " for each octet ";
    
    var errMsgObjL10n = document.getElementById ('hd.remLeadingZero');
    if (errMsgObjL10n) errMsgL10n1 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter1');
    if (errMsgObjL10n) errMsgL10n2 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter2');
    if (errMsgObjL10n) errMsgL10n3 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter3');
    if (errMsgObjL10n) errMsgL10n4 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter4');
    if (errMsgObjL10n) errMsgL10n5 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter5');
    if (errMsgObjL10n) errMsgL10n7 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.plsEnterValBet');
    if (errMsgObjL10n) errMsgL10n6 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.invalOctateLen');
    if (errMsgObjL10n) errMsgL10n8 = errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.foreachoctate');
    if (errMsgObjL10n) errMsgL10n9 = " " + errMsgObjL10n.value + " ";
    /* L10N Error Message Collection End */

    var ipOctetMinVal = 0;
    var ipOctetMaxVal = 255;
    var isFirstByteZero = false;
    var isError = false;
    var ipOctetSpecified = false;
    var errMsg = '';
   	var tblIPAddrId = "";
	if (objArr[0].disabled) return true;
    for (var i = 0; i < objArr.length; i++)
         {
		 if (objArr[i].disabled) break;
         ipOctetMinVal = 0;
         ipOctetMaxVal = 255;
         isError = false;
         var value = objArr[i].value;
         var errMsg = '';
		
		 if (((i+1) == 1) && (ipv4AddrTypeStr == 'IP' || ipv4AddrTypeStr == 'SN'))
             {
			/*     first octet should not exced 223 */                 
             ipOctetMinVal = 1;
             ipOctetMaxVal = 223;
             }
         
         if (((i+1) == 4) && (ipv4AddrTypeStr == 'IP'))
             {
             /* last octet should not set to zero as this is network ip */
             ipOctetMinVal = 0;
             ipOctetMaxVal = 255;                          
             } 
         if (((i+1) == 4) && (ipv4AddrTypeStr == 'SN'))
             {
             /* last octet can be zero as this is subnet ip */
             ipOctetMinVal = 0;
             ipOctetMaxVal = 254;                          
             } 
         
         if (!isNaN(parseInt(value)) && (value.length != (parseInt (value)+"").length))
            {
            if (prefixStr) errMsg = prefixStr;
            errMsg += errMsgL10n1 + (i + 1);
			if (document.getElementById(tblIPAddrId+"Err"))
				document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
			else
				alert (errMsg);
			objArr[i].focus ();
            return false;
            }
         if (alertFlag)
             {
             if (prefixStr) errMsg = prefixStr;
             if ((ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM') && ((i+1) == 1))
                 errMsg += errMsgL10n2;
             else if ((ipv4AddrTypeStr == 'SM') && ((i+1) == 4))
                 {
                 if (objArr[i-1].value != "255")
                     errMsg += errMsgL10n3;
                 else
                     errMsg += errMsgL10n4;
                 }
             else if ((ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM') && ((i+1) > 1))
                 {
                 if (objArr[i-1].value != "255")
                     errMsg += errMsgL10n3;
                 else
                     errMsg += errMsgL10n5;
                 }
             else
                 {
                 errMsg += errMsgL10n6 + ipOctetMinVal +
                       " - " + ipOctetMaxVal + " ";
                 }
             if (suffixStr) errMsg += suffixStr;
             }
         if (value.length == 0 || value.length > 3 || (optFlag && !ipOctetSpecified && !isNaN(parseInt(value)) && parseInt(value)==0))
             {
             if (optFlag && !ipOctetSpecified)
                 {
                 continue;
                 }
             var j = 0;
             if (i == 0)
                 {
                  /* check for full empty IP address */
                 for (j = i; j < objArr.length; ++j)
                     {
                     if (objArr[j].value.length)
                         break;
                      }
                 }
             if (errMsg)
                 {
                 if ((i == 0) && (j == objArr.length) && errMsg)
                     {
                     if (ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM')
						{
						if (alertFlag)
							{
							errMsg = prefixStr + errMsgL10n7;
							if (document.getElementById(tblIPAddrId+"Err"))
								document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
							else
								alert (errMsg);
							}
						}
                     else
						{
                        if (alertFlag)
							{
							errMsg = prefixStr + errMsgL10n6 + ipOctetMinVal + " - " + ipOctetMaxVal + " " + errMsgL10n9;
							if (document.getElementById(tblIPAddrId+"Err"))
								document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
							else
								alert (errMsg);
							}
						}
                     }
                 else
                     {
                     if (octetShowFlag)
                     	{
						if (value.length > 3)
							errMsg = errMsgL10n8 + (i+1);
						else
							errMsg += (i+1);
                     	}
					 if (alertFlag)
						{
							if (document.getElementById(tblIPAddrId+"Err"))
								document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
							else
								alert (errMsg);
						}

                     }
                 }
             objArr[i].focus ();
             return false;
             }
         if (optFlag)
             {
             if (i > 0 && !ipOctetSpecified)
                 {
				 errMsg = prefixStr;
                 if (errMsg)
                     {
                     //if (octetShowFlag) errMsg += 0;
                     //alert (errMsg);
					 if (alertFlag)
						{
							if (document.getElementById(tblIPAddrId+"Err"))
								document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
							else
								alert (errMsg);
						}
                     }
                 objArr[0].focus ();
                 return false;
                 }
             ipOctetSpecified = true;
             }

         if (ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM')
             {
             if ((i+1) == 1)
                isError = !checkSnetMask (value, 8, 8);
		     else if (((i+1) == 4) && ipv4AddrTypeStr == 'SM')
                {
                if (objArr[i-1].value != "255")
                    isError = !checkSnetMask (value, 0, 0);
                else
                    isError = !checkSnetMask (value, 0, 6);
                }
             else
                {
                if (objArr[i-1].value != "255")
                    isError = !checkSnetMask (value, 0, 0);
                else
                    isError = !checkSnetMask (value, 0, 8);
                }
             }
         else
             {
             if (isNaN(parseInt (value)) || (((parseInt (value) > 0) && isFirstByteZero) ||
                 (parseInt (value) < ipOctetMinVal || parseInt (value) > ipOctetMaxVal)))
                 {
                 isError = true;
                 }
             }
         if (isError)
             {
             if (isFirstByteZero) --i;
             if (alertFlag)
                 {
                 if (prefixStr) errMsg = prefixStr;
                 if ((ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM') && ((i+1) == 1))
                     errMsg += errMsgL10n2;
                 else if ((ipv4AddrTypeStr == 'SM') && ((i+1) == 4))
                     {
                     if (objArr[i-1].value != "255")
                         errMsg += errMsgL10n3;
                     else
                         errMsg += errMsgL10n4;
                     }
                 else if ((ipv4AddrTypeStr == 'SM' || ipv4AddrTypeStr == 'SNM') && ((i+1) > 1))
                     {
                     if (objArr[i-1].value != "255")
                         errMsg += errMsgL10n3;
                     else
                         errMsg += errMsgL10n5;
                     }
                 else
                     {
                     errMsg += errMsgL10n6 + ipOctetMinVal +
                               " - " + ipOctetMaxVal + " ";
                     }
                 if (suffixStr) errMsg += suffixStr;
                 if (octetShowFlag) errMsg += (i+1);
      			 if (document.getElementById(tblIPAddrId+"Err"))
					document.getElementById(tblIPAddrId+"Err").innerHTML = errMsg;
				 else
					alert (errMsg);
				 }
             objArr[i].focus ();
             return false;
             }
         }
	 if (document.getElementById(tblIPAddrId+"Err"))
		document.getElementById(tblIPAddrId+"Err").innerHTML = "";
     return true;
     }
     
function ipv4AddrFormatCheck1
    (objArr, ipv4AddrTypeStr, optFlag, alertFlag, prefixStr, suffixStr, octetShowFlag)
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = " remove leading 0's for octet ";
    var errMsgL10n2 = " Please enter 255 ";
    var errMsgL10n3 = " Please enter 0 ";
    var errMsgL10n4 = " Please enter 0/128/192/224/240/248/252 ";
    var errMsgL10n5 = " Please enter 0/128/192/224/240/248/252/254/255 ";
    var errMsgL10n6 = " Please enter a value between ";
    var errMsgL10n7 = "Please enter a value 0/128/192/224/240/248/252/254/255 for each octet.";
    var errMsgL10n8 = "Invalid octet length for octet ";
    var errMsgL10n9 = " for each octet ";
    var errMsgL10n10 = "IP address not specified. Please enter a values between 0 to 255 for each octet.";
    
    var errMsgObjL10n = document.getElementById ('hd.remLeadingZero');
    if (errMsgObjL10n) errMsgL10n1 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter1');
    if (errMsgObjL10n) errMsgL10n2 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter2');
    if (errMsgObjL10n) errMsgL10n3 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter3');
    if (errMsgObjL10n) errMsgL10n4 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter4');
    if (errMsgObjL10n) errMsgL10n5 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.plsEnter5');
    if (errMsgObjL10n) errMsgL10n7 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.plsEnterValBet');
    if (errMsgObjL10n) errMsgL10n6 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.invalOctateLen');
    if (errMsgObjL10n) errMsgL10n8 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.foreachoctate');
    if (errMsgObjL10n) errMsgL10n9 = " " + errMsgObjL10n.value + " ";
	errMsgObjL10n = document.getElementById ('hd.ipAddrNtSpecified');
    if (errMsgObjL10n) errMsgL10n10 = errMsgObjL10n.value;
    /* L10N Error Message Collection End */

    var ipOctetMinVal = 0;
    var ipOctetMaxVal = 255;
    var isFirstByteZero = false;
    var isError = false;
    var ipOctetSpecified = false;
    var errMsg = '';
    if (objArr[0].disabled) return true;
    
    for (var i = 0; i < objArr.length; i++)
         {
         if (objArr[i].disabled) break;
         ipOctetMinVal = 0;
         ipOctetMaxVal = 255;
         isError = false;
         var value = objArr[i].value;
         var errMsg = '';
         if (alertFlag)
             {
             if (prefixStr) errMsg = prefixStr;
             errMsg += errMsgL10n6 + ipOctetMinVal +
                       " - " + ipOctetMaxVal + " ";
             if (suffixStr) errMsg += suffixStr;
             }
         if (value.length == 0)
             {
             if (optFlag && !ipOctetSpecified)
                 {
                 continue;
                 }
             var j = 0;
             if (i == 0)
                 {
                  /* check for full empty IP address */
                 for (j = i; j < objArr.length; ++j)
                     {
                     if ((objArr[j].value).length)
                         break;
                      }
                 }
             if (errMsg)
                 {
                 if ((i == 0) && (j == objArr.length) && errMsg)
                     alert (errMsgL10n10);
                 else
                     {
                     if (octetShowFlag) errMsg += (i+1);
                     alert (errMsg);
                     }
                 }
             objArr[i].focus ();
             return false;
             }
         if (optFlag)
             {
             if (i > 0 && !ipOctetSpecified)
                 {
                 if (errMsg)
                     {
                     if (octetShowFlag) errMsg += (i+1);
                     alert (prefixStr);
                     }
                 objArr[i].focus ();
                 return false;
                 }
             ipOctetSpecified = true;
             }

		 if (((i+1) == 1) && (ipv4AddrTypeStr == 'IP' || ipv4AddrTypeStr == 'SN'))
             {
			/* first octet should not exced 223 */                 
             ipOctetMinVal = 1;
             ipOctetMaxVal = 223;
             }
         
         if (((i+1) == 4) && (ipv4AddrTypeStr == 'IP'))
             {
             /* last octet should not set to zero as this is network ip */
             ipOctetMinVal = 1;
             ipOctetMaxVal = 254;                          
             } 
         if (((i+1) == 4) && (ipv4AddrTypeStr == 'SN'))
             {
             /* last octet can be zero as this is subnet ip */
             ipOctetMinVal = 0;
             ipOctetMaxVal = 254;                          
             } 
             
         if (((parseInt (value) > 0) && isFirstByteZero) ||
             (parseInt (value) < ipOctetMinVal || parseInt (value) > ipOctetMaxVal))
             {
             isError = true;
             }
         if (isError)
             {
             if (isFirstByteZero) --i;
             if (alertFlag)
                 {
                 if (prefixStr) errMsg = prefixStr;
                 errMsg += errMsgL10n6 + ipOctetMinVal +
                           " - " + ipOctetMaxVal + " ";
                 if (suffixStr) errMsg += suffixStr;
                 if (octetShowFlag) errMsg += (i+1);
                 alert (errMsg);
                 }
             return false;
             }
         }
     return true;
     }
     
function ipv4AddrNoZero (ipv4TblId, alertFlag, errMsg)
    {
    if (!ipv4TblId) return false;
    var obj = document.getElementById(ipv4TblId);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    var ipValue = "";
    for (var i = 0; i < objArr.length; i++)
         {
         if (objArr[i].disabled) break;
         ipValue += objArr[i].value;
         }
    if (parseInt (ipValue, 10) <= 0)
         {
         if (alertFlag)
              alert (errMsg);
         return false;
         }
    return true;
    }

/* Converts IP string to an int */
function convert_addr(ipchars) {
    var bytes = ipchars.split('.');
    var result = ((bytes[0] & 0xff) << 24) |
                 ((bytes[1] & 0xff) << 16) |
                 ((bytes[2] & 0xff) <<  8) |
                  (bytes[3] & 0xff);
    return result;
}

/* Converts IP string to an int */
function getIPInt(tblName) {
    var obj = document.getElementById(tblName);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    octet0 =  objArr[0].value;
    octet1 =  objArr[1].value;
    octet2 =  objArr[2].value;
    octet3 =  objArr[3].value  ;

    var result = ((octet0 & 0xff) << 24) |
                 ((octet1 & 0xff) << 16) |
                 ((octet2 & 0xff) <<  8) |
                  (octet3 & 0xff);
    return result;
}

function getIPInt1(srcObjId) {
    if (!srcObjId) return false;
    var obj = document.getElementById(srcObjId);
    if (!obj) return false;
    var ipaddr = obj.value;
    var objArr = ipaddr.split (".");
    if (!objArr.length) return false;
    octet0 =  objArr[0];
    octet1 =  objArr[1];
    octet2 =  objArr[2];
    octet3 =  objArr[3];

    var result = ((octet0 & 0xff) << 24) |
                 ((octet1 & 0xff) << 16) |
                 ((octet2 & 0xff) <<  8) |
                  (octet3 & 0xff);
    return result;
}

/*
 * Compares two IPs and returns
 *  +ve number if Ip1 > IP2,
 *  0 if they are equal
 *  -ve number if IP1 < IP2.
 */

function compareIP(ip1Int, ip2Int) {
    if (ip1Int > ip2Int) return 1;
    if (ip1Int < ip2Int) return -1;
    return 0;
}

function compareIPRange(ip1Int, ip2Int) {
    if ((ip2Int - ip1Int) <= 254) return 1;
    return 0;
}

/* Check an IP (host) falls in a subnet */
function isInSubnet(host, pattern, mask) {
    return ((host & mask) == (pattern & mask)); }

/*
 * checks if an IP address is in a network.
 * params: ipaddr => IP to be checked (string)
 *         pattern => IP address pattern
 *       maskstr => Subnet mask
 */

function isInSubnetStr(ipaddr, pattern, maskstr) {
    var test = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/(ipaddr);
    if (test == null) {
        ipaddr = 'null'; /* dnsResolve(ipaddr);*/ /*prasanna*/
        if (ipaddr == 'null')
            return false;
    } else if (test[1] > 255 || test[2] > 255 ||
               test[3] > 255 || test[4] > 255) {
        return false;    // not an IP address
    }
    var host = convert_addr(ipaddr);
    var pat  = convert_addr(pattern);
    var mask = convert_addr(maskstr);
    return ((host & mask) == (pat & mask)); 
    }

/* Gets IP address string by cat'ing the 4 octets  */
function getIPStr(tblName)
	{
    var obj = document.getElementById(tblName);
    var objArr = obj.getElementsByTagName("INPUT");
    if (!objArr.length) return false;
    return '' + objArr[0].value + '.' +
                objArr[1].value + '.' +
                objArr[2].value + '.' +
                objArr[3].value  ;
	}

function getIPStr1(srcObjId)
	{
    if (!srcObjId) return false;
    var obj = document.getElementById(srcObjId);
    if (!obj) return false;
    return obj.value;
	}
	
function ipRangeValidate (ipAddrStartId, ipAddrEndId, errPrefix)
	{
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = "End IP address must greater than or equal to the start IP address";
    var errMsgObjL10n = document.getElementById ('hd.endIpGrtrThnStrtIp');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    /* L10N Error Message Collection End */
    
	var errorFlag = false;	
    if (!ipAddrStartId || !ipAddrEndId) return true;
    var startIpObj = document.getElementById(ipAddrStartId);
    var endIpObj = document.getElementById(ipAddrEndId);
    if (!startIpObj || !endIpObj) return true;
    var startIpArray = startIpObj.getElementsByTagName("INPUT");
    var endIpArray = endIpObj.getElementsByTagName("INPUT");

    if (!startIpArray || startIpArray.length == 0 || startIpArray[0].disabled ||
        !endIpArray || endIpArray.length == 0 || endIpArray[0].disabled) return true;

    var startIpObj= getIPStr(ipAddrStartId);
	var endIpObj= getIPStr(ipAddrEndId);

    var startObjArr = startIpObj.split (".");

    var endObjArr = endIpObj.split (".");

    if (startObjArr.length != 4 || endObjArr.length != 4) return true;

	/* Check IP Address Octet Range */
	if (ipAddrOctetCheck (startObjArr) == false)
		return true;

	if (ipAddrOctetCheck (endObjArr) == false)
		return true;

	/* Checking First Octet */
   	var startIpOctet = parseInt (startObjArr[0], 10);
   	var endIpOctet = parseInt (endObjArr[0], 10);
   	if (startIpOctet > endIpOctet )
    	errorFlag = true;
   	else if (startIpOctet == endIpOctet)
		{
   		startIpOctet = parseInt (startObjArr[1], 10);
   		endIpOctet = parseInt (endObjArr[1], 10);
        /* Checking Second Octet */
	   	if (startIpOctet > endIpOctet)
	   		errorFlag = true;
	   	else if (startIpOctet == endIpOctet)
			{
	   		startIpOctet = parseInt (startObjArr[2], 10);
	   		endIpOctet = parseInt (endObjArr[2], 10);
            /* Checking Third Octet */
		   	if (startIpOctet > endIpOctet)
		   		errorFlag = true;
		   	else if (startIpOctet == endIpOctet)
				{
		   		startIpOctet = parseInt (startObjArr[3], 10);
		   		endIpOctet = parseInt (endObjArr[3], 10);
                /* Checking Fourth Octet */
			   	if (startIpOctet >= endIpOctet)
			   		errorFlag = true;
				}   					
			}   		
		}
		
	if (errorFlag)
		{
		var errorStr = ""
		if (errPrefix) errorStr = errPrefix + ": "
		errorStr += errMsgL10n1;
		if (document.getElementById(ipAddrEndId + "Err"))
			document.getElementById(ipAddrEndId + "Err").innerHTML = errorStr
		else
			alert (errorStr)
			
		endIpArray[0].focus();
		return false;
		}
	if (document.getElementById(ipAddrEndId + "Err"))
		document.getElementById(ipAddrEndId + "Err").innerHTML = ""
	return true;
	}	

function ipAddrOctetCheck (ipObjArr)
	{
	for (var i = 0; i < ipObjArr.length; i++)
		{
		var octet = ipObjArr[i];
		if (octet == "" || isNaN (octet))
			return false;
		if (i == 0)
			{
			if (parseInt (octet, 10) < 0 || parseInt (octet, 10) > 223)
				return false;
			}
		else if (i == 3)
			{
			if (parseInt (octet, 10) < 0 || parseInt (octet, 10) > 255)
				return false;
			}
		else
			{
			if (parseInt (octet, 10) < 0 || parseInt (octet, 10) > 255)
				return false;
			}		
		}
	return true;
	}
/* Subnet Validation*/
function subnetValidate (tblIpAddrId, tblSnetMaskId, suffixStr, optionalFlag)
	{
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = "Invalid octate." + "\n";
    var errMsgL10n2 = "Please enter 255 for 1st octate";
    var errMsgL10n3 = "Please enter one of 0/128/192/224/240/248/252/254/255 IP address for 2nd octate";
    var errMsgL10n4 = "Please enter one of 0/128/192/224/240/248/252/254/255 IP address for 3rd octate";
    var errMsgL10n5 = "Please enter one of 0/128/192/224/240/248/252/254/255 IP address for 4th octate";
    var errMsgL10n6 = "Please make sure subnet octate 1,2 and 3 are 255";
    var errMsgL10n7 = "Please make sure subnet octate 1,2 are 255";
    var errMsgL10n8 = "Please make sure that ocatate 2 is one of 0/128/192/224/240/248/252/254";
    var errMsgL10n9 = "Invalid Subnet "

    var errMsgObjL10n = document.getElementById ('hd.invalOctate');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value + "\n";
	errMsgObjL10n = document.getElementById ('hd.fstIpAddrOc');
	if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.secIpAddrOc');
	if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.thrdIpAddrOc');
	if (errMsgObjL10n) errMsgL10n4 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.frthIpAddrOc');
	if (errMsgObjL10n) errMsgL10n5 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.snAddr123');
	if (errMsgObjL10n) errMsgL10n6 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.snAddr12');
	if (errMsgObjL10n) errMsgL10n7 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.secOctateAddr');
	if (errMsgObjL10n) errMsgL10n8 = errMsgObjL10n.value;
	errMsgObjL10n = document.getElementById ('hd.invalRouteConf');
	if (errMsgObjL10n) errMsgL10n9 = errMsgObjL10n.value;
    /* L10N Error Message Collection End */

	var msg = errMsgL10n1;
	var ipAddr = getIPStr(tblIpAddrId);
	var snetMask = getIPStr(tblSnetMaskId);
    if (optionalFlag && ipAddr == "0.0.0.0" && snetMask == "0.0.0.0") return true;

        var ipAddrArr=new Array();
	var snetMaskArr=new Array();
	ipAddrArr=ipAddr.split(".");
	snetMaskArr=snetMask.split(".");

	if(snetMaskArr[0]!=255)
	{
		alert(errMsgL10n2);
	        return false;
        }
		
	if(snetMaskArr[1]!=0 && snetMaskArr[1]!=128 && snetMaskArr[1]!=192 && snetMaskArr[1]!=224 && snetMaskArr[1]!=240 && snetMaskArr[1]!=248 && snetMaskArr[1]!=252 && snetMaskArr[1]!=254 && snetMaskArr[1]!=255 )
	{	
		alert(msg + errMsgL10n3);
		return false;
	}
		

	if(snetMaskArr[2]!=0 && snetMaskArr[2]!=128 && snetMaskArr[2]!=192 && snetMaskArr[2]!=224 && snetMaskArr[2]!=240 && snetMaskArr[2]!=248 && snetMaskArr[2]!=252 && snetMaskArr[2]!=254 && snetMaskArr[2]!=255)
	{
		alert(msg + errMsgL10n4);
		return false;
	}

	if(snetMaskArr[3]!=0 && snetMaskArr[3]!=128 && snetMaskArr[3]!=192 && snetMaskArr[3]!=224 && snetMaskArr[3]!=240 && snetMaskArr[3]!=248 && snetMaskArr[3]!=252 && snetMaskArr[3]!=254 && snetMaskArr[3]!=255)
	{
		alert(msg + errMsgL10n5);
		return false;
	}

	if(snetMaskArr[3]!=0)
	{	 
		if(snetMaskArr[2]!=255 && snetMaskArr[1]!=255 && snetMaskArr[0]!=255) 
			{  
			alert(msg + errMsgL10n6);
			return false;
			}
	}
	else
	{
		if(snetMaskArr[2]!=0)
            	{  
			if(snetMaskArr[1]!=255 && snetMaskArr[0]!=255)
				{	
					alert(msg + errMsgL10n7);
					return false;
				}
    		}
        	else
		{	 
				if((snetMaskArr[1]!=0 && snetMaskArr[1]!=128 && snetMaskArr[1]!=192 && snetMaskArr[1]!=224 && snetMaskArr[1]!=240 && snetMaskArr[1]!=248 && snetMaskArr[1]!=252 && snetMaskArr[1]!=254) && snetMaskArr[0]!=255)
				{
					alert(msg + errMsgL10n8);
					return false;
				}
	        }
	}
		
    var	ipAddr_x1=(ipAddrArr[0] & snetMaskArr[0]);
	var	ipAddr_x2=(ipAddrArr[1] & snetMaskArr[1]);
	var	ipAddr_x3=(ipAddrArr[2] & snetMaskArr[2]);
	var	ipAddr_x4=(ipAddrArr[3] & snetMaskArr[3]);
	if(ipAddr_x1== ipAddrArr[0] && ipAddr_x2==ipAddrArr[1] && ipAddr_x3==ipAddrArr[2] && ipAddr_x4==ipAddrArr[3])
		return true;
	else
    	{
    	if (suffixStr)
			alert(errMsgL10n9+ suffixStr +"\n");
		else
			alert(errMsgL10n9 +"\n");
		return false;
        }
}
